1
0
mirror of git://git.sv.gnu.org/coreutils.git synced 2026-03-05 20:43:51 +02:00
Files
coreutils/tests/dd/misc
Paul Eggert 4e73fea3e3 Honor dd's noatime flag if possible, even if not supported on build fs
* doc/coreutils.texi (dd invocation): Warn that noatime might not be
reliable.
* src/dd.c (flags, usage): Look at O_NOATIME, not
HAVE_WORKING_O_NOATIME, to decide whether to support the noatime
flag, so that dd attempts O_NOATIME even if the build file system
does not support it.  Problem reported by Jim Meyering today in
bug-coreutils.
* tests/dd/misc: Generate a warning, not a failure, if noatime
exists but fails.
2007-02-22 19:09:35 +01:00

93 lines
2.7 KiB
Bash
Executable File

#!/bin/sh
# Ensure dd treats `--' properly.
# Also test some flag values.
# Copyright (C) 1999, 2004, 2005, 2006 Free Software Foundation, Inc.
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
tmp_in=dd-in.$$
tmp_in2=dd-in2.$$
tmp_sym=dd-sym.$$
tmp_out=dd-out.$$
if test "$VERBOSE" = yes; then
set -x
dd --version
fi
fail=0
warn=0
test_failure=0
echo data > $tmp_in || test_failure=1
ln $tmp_in $tmp_in2 || test_failure=1
ln -s $tmp_in $tmp_sym || test_failure=1
if test $test_failure = 1; then
echo 'failure in testing framework'
exit 1
fi
dd if=$tmp_in of=$tmp_out 2> /dev/null || fail=1
cmp $tmp_in $tmp_out || fail=1
rm $tmp_out
dd -- if=$tmp_in of=$tmp_out 2> /dev/null || fail=1
cmp $tmp_in $tmp_out || fail=1
if dd oflag=append if=$tmp_in of=$tmp_out 2> /dev/null; then
cmp $tmp_in $tmp_out || fail=1
fi
if dd iflag=nofollow if=$tmp_in count=0 2> /dev/null; then
dd iflag=nofollow if=$tmp_sym count=0 2> /dev/null && fail=1
fi
if dd iflag=directory if=. count=0 2> /dev/null; then
dd iflag=directory count=0 <. 2> /dev/null || fail=1
dd iflag=directory count=0 <$tmp_in 2> /dev/null && fail=1
fi
old_ls=`ls -u --full-time $tmp_in`
sleep 1
if dd iflag=noatime if=$tmp_in of=$tmp_out 2> /dev/null; then
new_ls=`ls -u --full-time $tmp_in`
if test "x$old_ls" != "x$new_ls"; then
cat >&2 <<EOF
=================================================================
$0: WARNING!!!
This operating system has the O_NOATIME file status flag,
but it is silently ignored in some cases.
Therefore, dd options like iflag=noatime may be silently ignored.
=================================================================
EOF
warn=77
fi
fi
if dd oflag=nolinks if=$tmp_in of=$tmp_out 2> /dev/null; then
dd iflag=nolinks if=$tmp_in > /dev/null 2>&1 && fail=1
dd iflag=nolinks < $tmp_in > /dev/null 2>&1 && fail=1
dd oflag=nolinks < $tmp_in > $tmp_out 2>&1 || fail=1
fi
outbytes=`echo x | dd bs=3 ibs=10 obs=10 conv=sync 2>/dev/null | wc -c`
test "$outbytes" -eq 3 || fail=1
rm -f $tmp_in $tmp_in2 $tmp_sym $tmp_out || fail=1
test $fail -eq 0 && fail=$warn
exit $fail